﻿using System;
using System.Collections.Generic;
using System.Collections;
using System.Linq;
using System.Text;
using NUnit.Framework;
using Invoice;
using Microsoft.Practices.EnterpriseLibrary.Data;
using Microsoft.Practices.EnterpriseLibrary.Data.Sql;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;
using System.Transactions;
using System.Data;
namespace InvoiceUnitTest
{
   
    [TestFixture]
    public class clsInvoiceUnitTest
    {       
        [Test]
        public void TestInvoiceCalculation()
        {
            clsInvoiceCalculation obj = new clsInvoiceCalculation();
            int intTotalCost = obj.CalculateCost(10, 20);
            Assert.AreEqual(200, intTotalCost);
        }
        
        [Test, TestCaseSource("TestCases")]
        public int TestInvoiceCalculation(int intPerProductCost,int intNumberOfProducts)
        {
            clsInvoiceCalculation obj = new clsInvoiceCalculation();
            return obj.CalculateCost(intPerProductCost, intNumberOfProducts);
       
        }
        public static IEnumerable TestCases
        {

            get
            {
                // This arraylist can be provided from database
                ArrayList objTestCaseData = new ArrayList();
                objTestCaseData.Add(new TestCaseData(10, 10).Returns(100));
                objTestCaseData.Add(new TestCaseData(20, 20).Returns(400));
                objTestCaseData.Add(new TestCaseData(30, 30).Returns(900));
                objTestCaseData.Add(new TestCaseData(5, 5).Returns(25));
                // This arraylist can be provided from database
                foreach (TestCaseData obj in objTestCaseData)
                {
                    yield return obj;
                }
                

            }

        }

        [Test,TestCaseSource("TestCasesCustomer")]
        public void TestCustomerInsert(string strCustomerCode,string strCustomerName)
        {
           
                clsCustomer objCust = new clsCustomer();
                objCust.CustomerCode = strCustomerCode;
                objCust.CustomerName = strCustomerName;
                objCust.Add();
                DataSet objDs = getCustomer(objCust.CustomerCode);
                Assert.AreEqual(objDs.Tables[0].Rows[0]["CustomerCode"],objCust.CustomerCode);
                Assert.AreEqual(objDs.Tables[0].Rows[0]["CustomerName"], objCust.CustomerName);
        }
        public static IEnumerable TestCasesCustomer
        {

            get
            {
                // This arraylist can be provided from database
                ArrayList objTestCaseData = new ArrayList();
                objTestCaseData.Add(new TestCaseData("", ""));
                objTestCaseData.Add(new TestCaseData("001", ""));
                objTestCaseData.Add(new TestCaseData("", "Shiv"));
                objTestCaseData.Add(new TestCaseData("001", "Shiv"));

                // This arraylist can be provided from database
                foreach (TestCaseData obj in objTestCaseData)
                {
                    yield return obj;
                }
            }
        }
        
        public DataSet getCustomer(string strCustomerCode)
        {
            Database objDb = DatabaseFactory.CreateDatabase("MyConnection");
            return objDb.ExecuteDataSet(CommandType.Text, "Select CustomerCode,CustomerName from Customer where CustomerCode='" + strCustomerCode + "'");
        }
       
        
    }
}
